#macro OcedarMale (RoChevG,RoChevD,RoGenG,RoGenD,RoHanG,
                   RoHanD,RoBuste,RoTete,RoEpG,RoEpD,
                   RoCouG,RoCouD,RoPoiG,RoPoiD)

#declare Main=
intersection {
 union {
       sphere {<0,0,0>,7.5 scale <1,2,1>}
       difference {
         sphere {<0,18,0>,4.5}
         box {<-10,10,.75>,<10,30,-.75>}
         cylinder {<0,18,-10>,<0,18,10>,1}
                }
       }
 plane {x,0 inverse rotate z*15}
 translate y*-18
}

#declare AvantBrasG=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-50,0>,9,1}
         sphere {<0,0,0>,9,1 scale <1,1.8,1> translate y*-18}
        }
      plane {y,0}
      plane {y,-42 inverse}
        }
 object {Main rotate RoPoiG translate y*-45}
 translate y*-4.5
}

#declare AvantBrasD=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-50,0>,9,1}
         sphere {<0,0,0>,9,1 scale <1,1.8,1> translate y*-18}
        }
      plane {y,0}
      plane {y,-42 inverse}
        }
 object {Main rotate RoPoiD translate y*-45}
 translate y*-4.5
}


#declare BicepsG=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-50,0>,10,1}
         sphere {<0,0,0>,10,1 scale <1,1.8,1> translate y*-12}
        }
      plane {y,0}
      plane {y,-45 inverse}
        }
  difference {sphere {<0,-64,0>,6.5} box {<-10,-60,-.75>,<10,-70,.75>}
                translate y*64 rotate x*-90 translate y*6}

  difference {sphere {<0,-64,0>,4.5} box {<-10,-60,-.75>,<10,-70,.75>}
                translate y*64 translate y*-48}
  object {AvantBrasG rotate RoCouG translate y*-48}
 translate y*-6
}

#declare BicepsD=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-50,0>,10,1}
         sphere {<0,0,0>,10,1 scale <1,1.8,1> translate y*-12}
        }
      plane {y,0}
      plane {y,-45 inverse}
        }
  difference {sphere {<0,-64,0>,6.5} box {<-10,-60,-.75>,<10,-70,.75>}
                translate y*64 rotate x*-90 translate y*6}

  difference {sphere {<0,-64,0>,4.5} box {<-10,-60,-.75>,<10,-70,.75>}
                translate y*64 translate y*-48}
  object {AvantBrasD rotate RoCouD translate y*-48}
 translate y*-6
}


#macro ConeRond (CoteC,CoteA,CoteB)
union {
sphere {<0,0,0>,CoteA}
sphere {<0,CoteC,0>,CoteB}
#local AngleC  = radians(90);
#local Rapport = sin(AngleC)/CoteC;
#local CoteE   = CoteA-CoteB;
#local AngleE  = asin (Rapport*CoteE);
cone {<0,sin(AngleE)*CoteA,0>,cos(AngleE)*CoteA,<0,sin(AngleE)*CoteB+CoteC,0>,cos(AngleE)*CoteB}
}
#end

#declare TeteOcedar=
union {
        intersection {
        object {ConeRond (30,10,15)}
        plane {y,0 inverse}
        plane {x,0 rotate z*-5 translate x*9.5 rotate y*20}
        plane {x,0 rotate z*-5 translate x*9.5 rotate y*-20}
        }
sphere {<0,-4,0>,9}
}

#declare Buste=
union {
intersection {
      blob {
        threshold .6
         cylinder {<0,0,0>,<0,30,0>,25,1}
         cylinder {<0,0,0>,<0,10,0>,20,1}

         sphere {<0,25,0>,25,1 scale <1.2,1,2>}
        }
 plane {y,0 inverse}
 plane {x,17}
 plane {x,0 rotate z*10 translate x*-8 inverse}
        translate y*.8
        }
object {TeteOcedar rotate RoTete translate <5,48,0>}
object {BicepsG rotate RoEpG translate <0,30,27>}
object {BicepsD rotate RoEpD translate <0,30,-27>}
}

#declare Panard=
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-35,0>,15,1}
         sphere {<0,0,0>,20,1 scale <1,1,1> translate y*-25}
        }
      plane {y,0}
      plane {y,-42 inverse}
      plane {x,0 inverse}
translate y*10 rotate z*90 translate y*-13
}

#declare TibiaG=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-70,0>,12,1}
         sphere {<0,0,0>,13,1 scale <1,2,1> translate y*-20}
        }
      plane {y,0}
      plane {y,-66 inverse}
        }
  difference {sphere {<0,0,0>,5} box {<-10,2,-.5>,<10,-6,.5>} translate y*-70 texture {Balsa}}
  object {Panard rotate RoChevG translate y*-70}
 translate y*-4
}

#declare TibiaD=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-70,0>,12,1}
         sphere {<0,0,0>,13,1 scale <1,2,1> translate y*-20}
        }
      plane {y,0}
      plane {y,-66 inverse}
        }
  difference {sphere {<0,0,0>,5} box {<-10,2,-.5>,<10,-6,.5>} translate y*-70 texture {Balsa}}
  object {Panard rotate RoChevD translate y*-70}
 translate y*-4
}

#declare CuisseG=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-70,0>,15,1}
         sphere {<0,0,0>,15,1 scale <1,1.5,1> translate y*-15}
        }
      plane {y,0}
      plane {y,-58 inverse}
        }
  difference {sphere {<0,-64,0>,6.5} box {<-10,-60,-.75>,<10,-70,.75>}}
  object {TibiaG rotate RoGenG translate y*-62}
 translate y*-5
}

#declare CuisseD=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-70,0>,15,1}
         sphere {<0,0,0>,15,1 scale <1,1.5,1> translate y*-15}
        }
      plane {y,0}
      plane {y,-58 inverse}
        }
  difference {sphere {<0,-64,0>,6.5} box {<-10,-60,-.75>,<10,-70,.75>}}
  object {TibiaD rotate RoGenD translate y*-62}
 translate y*-5
}

#declare Bassin=union {
intersection {
sphere {<0,0,0>,35/2 scale <1,1.9,1> translate y*15}
plane {y,0 inverse}
plane {y,35}
plane {x,0 rotate z*-18 translate x*11}
plane {x,0 rotate z*37 translate x*-10 inverse}
}
sphere {<0,35+7,0>,13}
difference {sphere {<0,-7,+10>,8} box {<-10,-2,10-.75>,<10,-16,10+.75>}}
difference {sphere {<0,-7,-10>,8} box {<10,-2,-10-.75>,<-10,-16,-10+.75>}}

}

union {
object {Buste rotate RoBuste translate y*(48)}
object {Bassin}
object {CuisseG rotate RoHanG translate <0,-7,+10>}
object {CuisseD rotate RoHanD translate <0,-7,-10>}
texture {T_Wood23 scale 30 rotate <90,20,10> finish {phong .5 reflection .1}}
}
#end

#macro OcedarFemale (RoChevG,RoChevD,RoGenG,RoGenD,RoHanG,
                   RoHanD,RoBuste,RoTete,RoEpG,RoEpD,
                   RoCouG,RoCouD,RoPoiG,RoPoiD)

#declare Main=
intersection {
 union {
       sphere {<0,0,0>,7.5 scale <1,2,1>}
       difference {
         sphere {<0,18,0>,4.5}
         box {<-10,10,.75>,<10,30,-.75>}
         cylinder {<0,18,-10>,<0,18,10>,1}
                }
       }
 plane {x,0 inverse rotate z*15}
 translate y*-18
}

#declare AvantBrasG=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-50,0>,9,1}
         sphere {<0,0,0>,9,1 scale <1,1.8,1> translate y*-18}
        }
      plane {y,0}
      plane {y,-42 inverse}
        }
 object {Main rotate RoPoiG translate y*-45}
 translate y*-4.5
}

#declare AvantBrasD=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-50,0>,9,1}
         sphere {<0,0,0>,9,1 scale <1,1.8,1> translate y*-18}
        }
      plane {y,0}
      plane {y,-42 inverse}
        }
 object {Main rotate RoPoiD translate y*-45}
 translate y*-4.5
}


#declare BicepsG=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-50,0>,10,1}
         sphere {<0,0,0>,10,1 scale <1,1.8,1> translate y*-12}
        }
      plane {y,0}
      plane {y,-45 inverse}
        }
  difference {sphere {<0,-64,0>,6.5} box {<-10,-60,-.75>,<10,-70,.75>}
                translate y*64 rotate x*-90 translate y*6}

  difference {sphere {<0,-64,0>,4.5} box {<-10,-60,-.75>,<10,-70,.75>}
                translate y*64 translate y*-48}
  object {AvantBrasG rotate RoCouG translate y*-48}
 translate y*-6
}

#declare BicepsD=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-50,0>,10,1}
         sphere {<0,0,0>,10,1 scale <1,1.8,1> translate y*-12}
        }
      plane {y,0}
      plane {y,-45 inverse}
        }
  difference {sphere {<0,-64,0>,6.5} box {<-10,-60,-.75>,<10,-70,.75>}
                translate y*64 rotate x*-90 translate y*6}

  difference {sphere {<0,-64,0>,4.5} box {<-10,-60,-.75>,<10,-70,.75>}
                translate y*64 translate y*-48}
  object {AvantBrasD rotate RoCouD translate y*-48}
 translate y*-6
}


#macro ConeRond (CoteC,CoteA,CoteB)
union {
sphere {<0,0,0>,CoteA}
sphere {<0,CoteC,0>,CoteB}
#local AngleC  = radians(90);
#local Rapport = sin(AngleC)/CoteC;
#local CoteE   = CoteA-CoteB;
#local AngleE  = asin (Rapport*CoteE);
cone {<0,sin(AngleE)*CoteA,0>,cos(AngleE)*CoteA,<0,sin(AngleE)*CoteB+CoteC,0>,cos(AngleE)*CoteB}
}
#end

#declare TeteOcedar=
union {
        intersection {
        object {ConeRond (30,10,15)}
        plane {y,0 inverse}
        plane {x,0 rotate z*-5 translate x*9.5 rotate y*20}
        plane {x,0 rotate z*-5 translate x*9.5 rotate y*-20}
        }
sphere {<0,-4,0>,9}
}

//******************************************************************************
//      ICI
//******************************************************************************
#declare Buste=
union {
intersection {
      blob {
        threshold .6
         cylinder {<0,0,0>,<0,30,0>,25,1}
         cylinder {<0,0,0>,<0,10,0>,20,1}
         sphere {<13,20,-12>,15,1}
         sphere {<13,20,12>,15,1}

         sphere {<0,25,0>,25,1 scale <1.2,1,2>}
        }
 plane {y,0 inverse}
 //plane {x,17}
 plane {x,0 rotate z*10 translate x*-8 inverse}
        translate y*.8
        }
object {TeteOcedar rotate RoTete translate <5,48,0>}
object {BicepsG rotate RoEpG translate <0,30,27>}
object {BicepsD rotate RoEpD translate <0,30,-27>}
}

#declare Panard=
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-35,0>,15,1}
         sphere {<0,0,0>,20,1 scale <1,1,1> translate y*-25}
        }
      plane {y,0}
      plane {y,-42 inverse}
      plane {x,0 inverse}
translate y*10 rotate z*90 translate y*-13
}

#declare TibiaG=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-70,0>,12,1}
         sphere {<0,0,0>,13,1 scale <1,2,1> translate y*-20}
        }
      plane {y,0}
      plane {y,-66 inverse}
        }
  difference {sphere {<0,0,0>,5} box {<-10,2,-.5>,<10,-6,.5>} translate y*-70 texture {Balsa}}
  object {Panard rotate RoChevG translate y*-70}
 translate y*-4
}

#declare TibiaD=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-70,0>,12,1}
         sphere {<0,0,0>,13,1 scale <1,2,1> translate y*-20}
        }
      plane {y,0}
      plane {y,-66 inverse}
        }
  difference {sphere {<0,0,0>,5} box {<-10,2,-.5>,<10,-6,.5>} translate y*-70 texture {Balsa}}
  object {Panard rotate RoChevD translate y*-70}
 translate y*-4
}

#declare CuisseG=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-70,0>,15,1}
         sphere {<0,0,0>,15,1 scale <1,1.5,1> translate y*-15}
        }
      plane {y,0}
      plane {y,-58 inverse}
        }
  difference {sphere {<0,-64,0>,6.5} box {<-10,-60,-.75>,<10,-70,.75>}}
  object {TibiaG rotate RoGenG translate y*-62}
 translate y*-5
}

#declare CuisseD=
union {
  intersection {
      blob {
        threshold .6
         cylinder {<0,10,0>,<0,-70,0>,15,1}
         sphere {<0,0,0>,15,1 scale <1,1.5,1> translate y*-15}
        }
      plane {y,0}
      plane {y,-58 inverse}
        }
  difference {sphere {<0,-64,0>,6.5} box {<-10,-60,-.75>,<10,-70,.75>}}
  object {TibiaD rotate RoGenD translate y*-62}
 translate y*-5
}

#declare Bassin=union {
intersection {
sphere {<0,0,0>,35/2 scale <1,1.9,1> translate y*15}
plane {y,0 inverse}
plane {y,35}
plane {x,0 rotate z*-18 translate x*11}
plane {x,0 rotate z*37 translate x*-10 inverse}
}
sphere {<0,35+7,0>,13}
difference {sphere {<0,-7,+10>,8} box {<-10,-2,10-.75>,<10,-16,10+.75>}}
difference {sphere {<0,-7,-10>,8} box {<10,-2,-10-.75>,<-10,-16,-10+.75>}}

}

union {
object {Buste rotate RoBuste translate y*(48)}
object {Bassin}
object {CuisseG rotate RoHanG translate <0,-7,+10>}
object {CuisseD rotate RoHanD translate <0,-7,-10>}
texture {T_Wood23 scale 30 rotate <90,20,10> finish {phong .5 reflection .1}}
}
#end

/*#macro OcedarMale (RoChevG,RoChevD,RoGenG,RoGenD,
                     RoHanG,RoHanD,RoBuste,RoTete,
                     RoEpG,RoEpD,
                     RoCouG,RoCouD,RoPoiG,RoPoiD)*/

#declare Ocedar_Pose_1 =
object {OcedarMale (z*-10,0,z*-120,z*-110,
                    z*5,z*100,z*-20,z*-20,
                    <20,0,110>,z*20,
                    x*30,0,<0,-90,20>,0)}

#declare Ocedar_Pose_2 =
object {OcedarFemale (0,0,z*-40,z*-50,0,0,0,0,0,0,0,z*40,0,0)}
